// http://eslint.org/docs/user-guide/configuring

module.exports = {
    'env': {
        'browser': true,
        'es6': true
    },
    'parserOptions': {
        'ecmaVersion': 2018
    },
    'extends': 'eslint:recommended',
    'globals': {
        'chrome': false
    },
    'rules': {
        'no-use-before-define': [
            'error',
            {'functions': false}
        ],
        'no-extra-parens': [
            'error'
        ],
        'indent': [
            'error', 4
        ],
        'no-trailing-spaces': [
            'error'
        ],
        'require-await': ['error'],
        'no-unneeded-ternary': ['error'],
        'linebreak-style': [
            'error',
            'unix'
        ],
        'quotes': [
            'error',
            'single'
        ],
        'semi': [
            'error',
            'always'
        ],
        'no-console': 'off',
        'no-unused-vars': ['warn', {
            'args': 'all',
            'argsIgnorePattern': '_'
        }],
        'max-len': ['warn', 100],
        'no-eval': ['error']
    }
};
