/** Commented because even with this do not works in Edge - and cannot open devtools
// https://stackoverflow.com/questions/48623669
// window.chrome = window.chrome || window.browser;
// Edge has only window.browser

// About offline: case: auth in new Chrome (not IS) - tokens synced, but not blobs

// TODO prepend global variables with g, like gAudio.
//
*/

/* global _updateIDB, stageUrlNew, uninstallURL */

let messages,
    gTimeStartedWaitingFirstAudio = 0,
    audio = [],
    audioCurrent = null,
    audioCurrentFeedEntityId = null,

    isIcoAnimating    = false,
    stillAddingToFeed = new Map(),
    stillCachingIds   = new Set();


chrome.storage.sync.get('lang', resp =>
    _getMessages(resp['lang'] || _getLang())  // eslint-disable-line no-undef
        .then(resp => messages = resp['messages'])
        .then(_buildContextMenu)
);

chrome.contextMenus.onClicked.addListener(_ => {
    addToFeedStarter();
});

function addToFeedStarter() {
    _getActiveTab(tabActive => {  // eslint-disable-line no-undef
        if (tabActive.url.match(/^chrome|^about/)) {
            // Opera with 'chrome://' too; Firefox: it is possible to inject into reader page
            _alert(messages['browserPage']['message']);
            // Firefox user will not see this alert, fuck with it (Valera said)
            // TODO error sound - get and cache this audio AFTER installation
        } else if (
            tabActive.url.match(
                /^https:\/\/(chrome.google.com\/webstore|addons.mozilla.org|addons.opera.com)/
            )
        ) {
            _alert(messages['storePage']['message']);
            // Firefox user will not see this alert, fuck it (Valera said)
        } else {  // ok it is usual page - let add it to feed
            chrome.tabs.detectLanguage(lang => {
            /* Detect language before content script - because user may switch the tab
             * while content script will fetch Wikipedia. */
                // eslint-disable-next-line no-undef
                if (chrome.runtime.lastError || _isLangSupported(lang)) {
                    /** lastError case: Opera -
                     * their defect that chrome.tabs.detectLanguage does not works
                     * from some version.
                     */
                    injectScript({
                        'operation': 'addToFeed',
                        'time': Date.now() / 1000 | 0,
                        'url': tabActive.url,
                        'favIconUrl': tabActive.favIconUrl,
                        'title': tabActive.title,
                        'tabId': tabActive.id,
                        'lang': lang !== 'und' ? lang : ''
                    });

                // For example currently we do not support Chinese and Arabic
                } else {
                    _alert(messages['languageNotSupported']['message']);
                }
            });
            chrome.tabs.insertCSS({'file': 'progress.css'});
            chrome.tabs.insertCSS({'file': 'snackbar.css'});
        }
    });
}

// https://developer.chrome.com/apps/runtime#event-onMessage
chrome.runtime.onMessage.addListener(message => {
    console.debug('eventPage: message:', message);

    switch (message['fromPopup']) {
    case '_initArticles':
        _initArticles(message['id_token'], message['history']);
        break;
    case '_cacheVoicePreview':
        indexedDB.open('intelligent-speaker').onsuccess =
            event => _cacheVoicePreview(message['id'], event.target.result);
        break;

    case '_cacheExisting':
        _cacheExisting(
            message['hashArticle'],
            +message['id'],
            message['voice'],
            +message['lenChunks'],
            message['idToken']
        );
        break;

    case 'getStatus':
        chrome.runtime.sendMessage({
            'toPopup': {
                'isPaused': audioCurrent ? audioCurrent.paused: null,

                // For faster init of rewind buttons
                'index': audioCurrent && audioCurrent.dataset['index'],
                'hasNextChunk': _getChunkNext() && _getChunkNext().readyState === 4,

                'audioCurrentFeedEntityId': audioCurrentFeedEntityId,
                'isPreparingPlaying': isIcoAnimating,
                'stillAddingToFeed': [...stillAddingToFeed]
                // Spread for converting Map to Array - stringifyiable datatype
            }
        });
        break;

    case 'addToFeed':
        if (!message['prefix']) {
            stillAddingToFeed.set(message['time'], {
                'favIconUrl': message['favIconUrl'],
                'url': message['url'],
                'title': message['title'],
            });

            /** Draw context through the content script because
             *  during fetching from Wikipedia this event page may be unloaded.
             */
            injectScript({
                'operation': message['fromPopup'],
                'time': message['time'],
                'url': message['url'],
                'favIconUrl': message['favIconUrl'],
                'title': message['title'],
                'lang': message['lang']
            });
        }
        break;

    case 'playFromFeed':
        if (audioCurrent) {
            stopPlaying();
        }
        playFromFeed(+message['id']);
        break;

    case 'downloadLocalOGGFromIndexedDB':
        // eslint-disable-next-line no-undef
        downloadLocalOGGFromIndexedDB(message['id']);
        break;

    case 'togglePlayedStatus':
        _setPlayedStatusInStorages(
            /* Plus convert to Number -
             * because on sending messages from one world to another they serialized to strings.
             */
            +message['id'],
            message['val']
        );
        break;

    case 'resume':
        audioCurrent.play();
        break;

    case 'pause':
        audioCurrent.pause();
        break;

    case 'stopPlaying':
        stopPlaying();
        break;

    case 'prevChunk':
        prevChunk();
        break;

    case 'nextChunk':
        nextChunk();
        break;

    case 'alterPlaybackRate':
        _setPlaybackRateToCurrentAudio(message['value']);
        break;

    case 'buildContextMenu':
        _buildContextMenu();
        break;
    }

    if (message['fromPopup'] && !message['prefix'])
        return;

    if (!_isLangSupported(message['lang']) && !message['prefix']) {  // eslint-disable-line no-undef
        stillAddingToFeed.clear();
        _alert(messages['languageNotSupported']['message']);
        _endProgressOnPage(message['tabId']);

        chrome.runtime.sendMessage({'toPopup': {
            // In case when adding a file
            'errorAddingToFeed': true,
            'reason': messages['languageNotSupported']['message']
        }});

        return;
    }

    addToFeedMessageHandler(message);


});

function addToFeedMessageHandler(message) {
    chrome.storage.sync.get(storageSync => {

        const callback = jsonTokens => addToFeed(
            Object.assign(storageSync, jsonTokens),
            message
        );

        const catchCallback = e => {
            _alert('Intelligent Speaker: error');
            _endProgressOnPage(message['tabId']);
            console.log(e);

            audioCurrentFeedEntityId = null;

            removeStubFromFeed(message['time']);
            chrome.runtime.sendMessage({'toPopup': {
                'playingFinished': true,
                'removeStubFromFeed': true}
            });

            throw e;
        };

        const anonOrAuthed = _ => {
            _keepTokenFresh(storageSync)  // eslint-disable-line no-undef
                .then(jsonTokenNew => {
                    callback(jsonTokenNew)
                        .catch(e => catchCallback(e));
                });
        };

        if (storageSync['isCognitoWasOpenedFromAnon']) {
            // eslint-disable-next-line no-undef
            _init(_getValueFromIdToken('email', storageSync))
                .then(tokens => {
                    if (tokens) {
                        callback(tokens)
                            .catch(e => catchCallback(e));
                        return;
                    }
                    anonOrAuthed();

                });

            return;
        }

        if (storageSync['state']) {
            _init(storageSync['state'])  // eslint-disable-line no-undef
                .then(tokens => callback(tokens))
                .catch(e => catchCallback(e));

            return;
        }

        if (!storageSync['id_token']) {
            const state = _getRandomString();  // eslint-disable-line no-undef
            chrome.storage.sync.set({'state': state});
            openCognitoPage(state);  // eslint-disable-line no-undef

            return;
        }

        anonOrAuthed();

    });
}


/**
 * https://developer.chrome.com/extensions/runtime#type-OnInstalledReason
 */
chrome.runtime.onInstalled.addListener(details => {

    if (details.reason === 'install') {

        fetch(`${stageUrlNew}createanonaccount`, {
            'method': 'POST'
        })
            .then(resp => resp.json())
            .then(resp => {
                chrome.storage.sync.set(resp);
            });

        // Set here because not synced with db, for sync - remove it and alter init.py
        chrome.storage.sync.set({
            'playbackRate': 1,
            'breathing': true,
            'chars_left': CHARS_IN_MINUTE * 60  // eslint-disable-line no-undef
        }, _ => {

            // Duplicated with common.js - user can remove because do not want to auth
            chrome.runtime.setUninstallURL(
                uninstallURL
            );
        });

    } else if (details.reason === 'update') {

        _convertVoicesStorageFormat();

    }

    indexedDB.open('intelligent-speaker', 2)
        .onupgradeneeded = onupgradeneeded;

});

// TODO someday remove this function, we have it for backward compatibility
function _convertVoicesStorageFormat() {
    chrome.storage.sync.get(async resp => {
        const voices = {};
        Object.entries(resp['voices']).forEach(([k, v]) => {
            if (typeof v === 'string') {
                voices[k] = [v];
            }
        });
        console.log('voices:', voices);
        chrome.storage.sync.set({'voices': voices});

        fetch(`${stageUrl}settings`, {  // eslint-disable-line no-undef
            'method': 'PUT',
            'headers': {
                // eslint-disable-next-line no-undef
                'Authorization': (await _keepTokenFresh())['id_token'],
                'Content-Type': 'application/json'
            },
            'body': JSON.stringify({'voices': voices})
            // Without stringify browser will not send the body
        });

    });
}

function onupgradeneeded(event) {
    const db = event.target.result;

    if (event.oldVersion === 0) {  // First extension install

        // TODO try without key path without index
        const objectStore = db.createObjectStore('voice-preview', {'keyPath': 'id'});
        objectStore.createIndex('id', 'id', {'unique': true});
        objectStore.transaction.oncomplete = function() {

            _getPopupDOM()
                .then(dom => {
                    for (const lang of _getLangsSupported(dom)) {
                        for (const voice of _getVoicesFromDOM(dom, lang, 'onupgradeneeded')) {
                            _cacheVoicePreview((voice['locale'] || lang) + '-' + voice, db);
                        }
                    }
                });
        };

        db.createObjectStore('articles');

    } else if (event.oldVersion === 1) {
        // Delete objectStore for articles - because was delivered with creating a wrong index
        // TODO remove someday this remove
        db.deleteObjectStore('articles');
        db.createObjectStore('articles');  // TODO add index 'hashArticle'?

        chrome.storage.sync.get(resp => {
            for (const k in resp) {
                if (k.match(/\d/)) {
                    _insertOrReplace(k, resp[k]);  // eslint-disable-line no-undef
                }
            }
        });

    }
}
async function _getPopupDOM() {
    if (_getPopupDOM['dom']) {
        console.log('Return popup.html DOM from cache');
        return _getPopupDOM['dom'];
    }
    console.time('_getPopupDOM');
    const resp = await fetch(chrome.runtime.getURL('popup.html'));
    const text = await resp.text();
    const dom = new DOMParser().parseFromString(text, 'text/html');

    // Because of false positive https://github.com/eslint/eslint/issues/11899
    // eslint-disable-next-line require-atomic-updates
    _getPopupDOM['dom'] = dom;
    console.timeEnd('_getPopupDOM');
    return dom;
}
function* _getLangsSupported(dom) {
    for (const node of dom.querySelectorAll('[data-lang]')) {
        yield node.dataset['lang'];
    }
}
class Voice {
    constructor(voice, locale, free) {
        this['voice'] = voice;
        this['locale'] = locale;
        this['free'] = free;
    }
    toString() {
        return this['voice'];
    }
    toJSON() {
        return this['voice'];
    }
    match(regex) {
        return this['voice'].match(regex);
    }
}
function* _getVoicesFromDOM(dom, lang, callee) {

    // TODO remove this debug?
    if (!lang) {
        throw new Error(`_getVoicesFromDOM: no lang; callee: ${callee}`);
    }

    for (const node of dom.querySelectorAll(`[data-lang=${lang}] [data-voice]`)) {
        yield new Voice(
            node.dataset['voice'],
            node.dataset['locale'],
            node.dataset['free'] === 'true');
    }
}
function _cacheVoicePreview(id, db) {
    fetch(`https://intelligent-speaker.com/voice-preview/${id}.ogg`)
        .then(resp => {
            if (!resp.ok) {
                console.log('HTTP status code:', resp.status);
                setTimeout(_cacheVoicePreview, 999, id, db);
            }

            return resp.blob();
        })
        .then(blob =>
            db.transaction('voice-preview', 'readwrite')
                .objectStore('voice-preview')
                .add({id, blob})
        )
        .catch(_ => setTimeout(_cacheVoicePreview, 999, id, db));
}
/**
 * Default param because of this bug report
 * https://habr.com/post/358374/#comment_18707895
 * May 2017: init.py returns empty list when no history,
 * but maybe sometimes API Gateway drops keys without values?
 */
function _initArticles(idToken, history=[]) {
    console.log('_initArticles(), history:', history);
    history.forEach((item, i) => {

        setTimeout(_ => _getPresignedUrls(
            item['hash_article'],
            item['voice'],
            item['len_chunks'],
            idToken)
            .then(urls => _cache(urls, item['utc'])),
        i * 4000);
        /** setTimeout against blocking of playing still uncached items -
         *  Chrome in parallel fetch maximum 10 files,
         *  if after install we cache big feed -
         *  try of playing uncached will put playing job at the end of queue
         *  and waiting time may be exhausted before first chunk and user will see the error,
         *  I faced with this case.
         */

        _insertOrReplace(  // eslint-disable-line no-undef
            item['utc'],
            _transformHistoryItemToTheFormatOfExtendion(item)
        );

    });
    chrome.runtime.sendMessage({
        'toPopup': {
            '_fillListAudio': true
        }
    });
}
/**
 * TODO use the same structure in the database and extension,
 * think about that after reusing audio chunks with all users.
 *
 */
function _transformHistoryItemToTheFormatOfExtendion(historyItem) {
    return {
        'hashArticle': historyItem['hash_article'],
        'lenChunks': historyItem['len_chunks'],
        'title': historyItem['title'],
        'voice': historyItem['VO'],
        'url': historyItem['url_article'],
        'favIconUrl': historyItem['favIconUrl'],
        'isNew': historyItem['isNew']
    };
}


function _cacheExisting(hashArticle, id, voice, lenChunks, idToken) {
    const args = `hashArticle: ${hashArticle}, id: ${id}, voice: ${voice}, lenChunks: ${lenChunks}`;
    console.debug(`_cacheExisting: ${args}`);
    _getPresignedUrls(hashArticle, voice, lenChunks, idToken)
        .then(urls => _cache(urls, id, false, {hashArticle, lenChunks}));
}

/**
 * We have this function because in Firefox impossible to alert
 * from background page (TODO check again in current Firefox).
 *
 * `Escaped` for multiline text - without that can not print.
 */
function _alert(text) {
    chrome.tabs.executeScript(
        {
            'code': `alert(\`${text}\`)`  // TODO add 'Intelligent Speaker' title?
        },
        _ => chrome.runtime.lastError &&
            console.log(
                'User tried to add internal browser page, this is normal for us to do nothing,',
                'original error:', chrome.runtime.lastError)
    );
}

function _alertError() {
    // TODO i18n
    _alert(`                    Intelligent Speaker text-to-speech:

Server Error. We have been notified about it. Sorry!

Please, try again later.

We appreciate you are with us
and we want to make sure our product brings joy and satisfaction to users!`);
}

function _buildContextMenu() {
    console.log('Build context menu');
    chrome.contextMenus.create({
        'title': messages['addToFeed']['message'],
        'id': 'root',
        'contexts': ['all']
    }, _ => {
        const err = chrome.runtime.lastError;
        if (err) {
            console.log('Context menu item already exists, just saying, err:', err.message);
        }
    });
}


class AudioExtended extends Audio {
    play() {
        audioCurrent = this;

        return new Promise((resolve, reject) => {
            chrome.storage.sync.get(resp => {
                this.playbackRate = resp['playbackRate'];
                super.play().then(resolve).catch(reject);
            });
        });
    }
    pause() {
        super.pause();

        dispatchEvent(new Event('pauseOrStop'));
    }
}

function showMessagePay() {
    console.log('showMessagePay');

    const message = chrome.runtime.getManifest().short_name.split('').join(' ') + '\n\n' +
                    messages['msg_exhausted_title']['message'] + '\n\n' +
                    messages['msg_exhausted_body']['message'];

    chrome.storage.sync.get(storageSync => {
        // TODO remove '.html' - new site on Hugo without it, grep all '.html' in extension
        const url = 'https://intelligent-speaker.com/pricing' +
            '?id_token=' + storageSync['id_token'] +
            '&refresh_token=' + storageSync['refresh_token'];

        // Not just confirm() because in Firefox will be nothing
        chrome.tabs.executeScript({  // TODO replace confirm() to Material dialog?
            'code': 'if(confirm(`' + message + '`)) location.href = "' + url + '"'
            // Multiline string must be between `` against 'Unterminated string literal' error
            // not open() because Firefox block it (with warning that popup was blocked)
        });
    });
}


/**
* Minour pros of server side extractor:
* 1 Better battery of user, faster install.
* 2. Against stealing of code.
*
* Cons: Money for Lambda
*/
async function addToFeed(storageSync, args) {
    console.log(arguments.callee.name, arguments);

    const voice = await _getVoice(
        (storageSync['voices'] || {})[args['lang']],
        args['lang']
    );

    console.log('voice:', voice);

    let url = stageUrlNew + 'addtofeed/';
    const headers = {
        'Authorization': storageSync['id_token'],
        'Content-Type': 'application/json'
    };
    const body = JSON.stringify({  // without JSON.stringify() body will be empty
        'utc': args['time'],
        'title': args['title'],
        'urlOfPage': args['url'],
        'favIconUrl': args['favIconUrl'],
        'lang': args['lang'],

        voice,
        'locale': voice ? voice['locale'] : await _getVoicesToLocales(storageSync['voices']),

        'breathing': storageSync['breathing'],

        'stringForVoicing': args['stringForVoicing'],
        'prefix': args['prefix']
    });

    // Do not use result from POST for playing audio because
    // the only way to do that is to create a blob and after that create a Link from blob
    // but that discard native audio streaming and
    // increase wasting time for user
    // https://stackoverflow.com/questions/44482967/mediasource-does-not-support-ogg-audio
    fetch(url, {
        'method': 'POST',
        headers,
        body
    }).then(fromBackend => {
        // TODO replace then() to the await and decrease intendantion?
        if (fromBackend.ok) {
            stillAddingToFeed.delete(args['time']);
            return fromBackend.json().then(function(fromBackend) {

                if (fromBackend['status_code'] === 'PAYMENT_REQUIRED') {
                    showMessagePay();
                    removeStubFromFeed(args['time']);
                }

                if (!fromBackend['presigned_urls']) {
                    console.log('No presigned urls from backend');
                    stopPlaying();

                    /** ApiGateway return stacktrace in case of error in Lambda.

                        TODO: setup ApiGateway to handle error from Lambda
                        to generic error BACKEND_ERROR - against exposing our backend code
                     */

                    // server do not extract text from html, for example empty page
                    if (fromBackend['status_code'] === 'TEXT_LENGTH_IS_ZERO') {
                        _alert(messages['snackbar_error_noTextHere']['message']);

                        chrome.runtime.sendMessage({'toPopup': {
                            'playingFinished': true,
                            'removeStub': true}
                        });
                        removeStubFromFeed(args['time']);
                    }

                    if (fromBackend['errorMessage']) {
                        //TODO upgrade extension and try again, if possible?
                        _alertError();
                        console.log(fromBackend);
                    }

                    if (args['tabId']) {
                        _endProgressOnPage(args['tabId']);
                    }

                    chrome.runtime.sendMessage({
                        'toPopup': {
                            'errorAddingToFeed': true
                        }
                    });

                    return;
                }

                console.log('Adding to feed, id for getting data from storage:', args['time']);
                const {hashArticle, lenChunks} =
                    _getMinimalUrlRepresentation(fromBackend['presigned_urls']);
                _insertOrReplace(args['time'], {  // eslint-disable-line no-undef
                    'url': args['url'],  // TODO rename url to urlOfPage like in db?
                    'favIconUrl': args['favIconUrl'],
                    'title': args['title'],
                    hashArticle,
                    lenChunks,
                    'isNew': true
                });
                _cache(fromBackend['presigned_urls'], args['time']);
                chrome.runtime.sendMessage(
                    {
                        'toPopup': 'addedToFeed',
                        'hashArticle': hashArticle,
                        'lenChunks':   lenChunks
                    }
                );

                if (args['tabId'])
                    // tabId is only when from context menu -
                    _endProgressOnPage(args['tabId'], 'snackbar_addedToFeed');
            });
        }
        _alertError();
    }).catch(e => {
        console.log(e);
        console.log('urlOfPage:', args['url']);
        console.log('title:', args['title']);
        console.log('stringForVoicing:', args['stringForVoicing']);
        _alert('Server unavailable, please try again');  // TODO i18n

        _endProgressOnPage(args['tabId']);

        // Unblock buttons
        chrome.runtime.sendMessage({
            'toPopup': {
                'playingFinished': true,
                'errorAddingToFeed': true
            }
        });

        audioCurrentFeedEntityId = null;
        stillAddingToFeed.delete(args['time']);
        removeStubFromFeed(args['time']);

        throw e;
    });
}
async function _getVoice(voicesForLang, lang) {
    console.log(`_getVoice(${voicesForLang}, ${lang})`);
    const dom = await _getPopupDOM();
    if (voicesForLang) {
        const voice = voicesForLang[_getRandomInt(voicesForLang.length)];
        const node = dom.querySelector(`[data-voice="${voice}"]`);
        return new Voice(
            voice,
            node.dataset['locale'],
            node.dataset['free'] === 'true'
        );
    }
    const firstVoiceInList = _getVoicesFromDOM(dom, lang, '_getVoice').next().value;
    return firstVoiceInList;
}
function _getRandomInt(maxExcluded) {
    return Math.random() * maxExcluded | 0;
}

async function _getVoicesToLocales(voicesObject=[]) {
    const myResp = {};
    for (const voices of Object.values(voicesObject)) {
        for await (const [voice, locale] of _getLocales(voices)) {
            myResp[voice] = locale;
        }
    }
    return myResp;
}
async function* _getLocales(voices) {
    for (const voice of voices) {
        yield [voice, await _getLocale(voice)];
    }
}
async function _getLocale(voice) {
    return (await _getPopupDOM()).querySelector(`[data-voice="${voice}"]`).dataset['locale'];
}

// TODO skip when played one-after-one, also use different color and tooltip onhover?..
//function _addLater(message) {
//    const args = {
//        'url': message['url'],
//        'favIconUrl': message['favIconUrl'],
//        'title': message['title'],
//        'stringForVoicing': message['stringForVoicing']
//    };
//
//    const request = indexedDB.open('intelligent-speaker');
//    request.onupgradeneeded = event => event.target.result
//        .createObjectStore('addLater');
//
//    request.onsuccess = event => {
//        const objectStore = event.target.result
//            .transaction('addLater', 'readwrite')
//            .objectStore('addLater');
//        const objectStoreRequest = objectStore.add(args, message['time']);
//        objectStoreRequest.onsuccess =
//            _ => chrome.runtime.sendMessage({'toPopup': 'addedToFeed'});
//    };
//    stillAddingToFeed.clear();
//}


function _endProgressOnPage(tabId, messagePlaceholder) {
    console.log(arguments.callee.name, arguments);

    // When progress bar was on UI - not on page
    if (!tabId) {
        return;
    }

    chrome.tabs.sendMessage(
        tabId,
        // eslint-disable-next-line no-undef
        {'snackbar--text': messagePlaceholder && messages[messagePlaceholder]['message']}
    );
}


function playFromFeed(id) {
    getFromObjectStore(id).then(feedEntity => {  // eslint-disable-line no-undef
        if (!feedEntity) {
            // Temp debug for prod clients - to receive email with this
            throw 'playFromFeed: no feedEntity by id: ' + id;
        }
        const urls = feedEntity['cache'] ?
            feedEntity['cache'].map(blob => URL.createObjectURL(blob))
            : [];
        console.debug('playFromFeed(), feedEntity:', feedEntity);
        chrome.storage.sync.get(storageSync => {
            if (feedEntity['cache'] && feedEntity['lenChunks'] === feedEntity['cache'].length) {
                // All chunks in cache
                _buildAudioChain(
                    id,
                    feedEntity['hashArticle'],
                    feedEntity['lenChunks'],
                    urls,
                );
            } else {
                _buildAudioChain(
                    id,
                    feedEntity['hashArticle'],
                    feedEntity['lenChunks'],
                    urls,
                    // eslint-disable-next-line no-undef
                    stillCachingIds.has(id) ? null : _keepTokenFresh(storageSync)
                        .then(jsonTokenNew => _getPresignedUrls(
                            feedEntity['hashArticle'],
                            feedEntity['voice'],
                            feedEntity['lenChunks'],
                            jsonTokenNew['id_token'],
                            feedEntity))
                );
            }
        });
        if (feedEntity['isNew']) {
            _setPlayedStatusInStorages(id, false);
        }
    });
    audioCurrentFeedEntityId = id;
}
function _buildAudioChain(id, hashArticle, lenChunks, urls, promiseUrls) {
    console.log(arguments.callee.name, arguments);
    if (promiseUrls) {  // while user listen for the first sentence - prepare all other audious
        promiseUrls.then(urls => _cache(urls, id, true));
    }

    for (let i = 0; i < lenChunks; i++) {
        console.log('Building audio chain, i:', i);
        audio[i] = new AudioExtended();
        audio[i].dataset['index'] = i;
        /** Define without src and add src later because may be the case when
         *  first chunk is ended and code below faced with 'ended' event
         *  where tried to play or attach event to play when 'canplay'
         *  and this HTMLMediaElement must already exists -
         *  we can attach event without src.
         *
         *  Without such separation you will face with
         *  `Cannot read property 'readyState' of undefined`.
         */

        /** We use here setTimeout() for the case when all chunks already on S3
         *  and cache of the browser is not used (because presigned urls always new -
         *  for chunks on S3 even setted header 'no-store')
         *  for example user listen from list feed - in such case readyState > 1
         *  for all chunks and browser fetch many chunks in parallel -
         *  because of that highly delayed playing of the article
         */
        gTimeStartedWaitingFirstAudio = Date.now();
        setTimeout(
            _ => {
                if (urls[i]) {
                    if (audio[i]) {
                        console.log('Set audio from urls');
                        audio[i].src = urls[i];
                    } else {
                        /** Checking here for audio existence because
                         * user can switch to the next article.
                         */
                        return;
                    }
                } else {
                    console.log('Chunk not in cache - stream from S3');
                    _getAudioLinkFromCache(id, i)  // Maybe still caching after adding
                        .then(objectUrl => {
                            console.log('Set src as blob url from cache');
                            audio[i].src = objectUrl;
                        })
                        .catch(e => {
                            console.debug(e);
                            promiseUrls && promiseUrls.then(urlsS3 => {
                                console.log('Get URL from promise');
                                urlsS3.forEach((urlS3, i) => {
                                    if (urlS3) {
                                        return;  // Like `continue` in old `for`
                                    }
                                    urls.set(i, urlS3);
                                });
                            });
                        });
                }
                playFirstChunkAndAttachAudioEvents(i, lenChunks, id, hashArticle);
            },
            i * (i < 3 || !promiseUrls ? 99 : 9999)
            /** TODO upgrade this naive approach to smarter more effective way
            /*  when always fetching a few chunks,
             *  not zero and not ten.
             */
        );

    }
}


function playFirstChunkAndAttachAudioEvents(j, lenChunks, id, hashArticle, isBlobMissing) {
    console.debug(arguments.callee.name, arguments);
    console.debug(
        'j:', j,
        'network state:', audio[0].networkState,
        'ready state:', audio[0].readyState,
        `audio[${j}].src:`, audio[j].src,
    );

    if (audio[j].readyState === 4 || audio[j].src.startsWith('blob')) {
        // `HAVE_ENOUGH_DATA: enough data is available — and the download rate is high enough`
        // https://developer.mozilla.org/en-US/docs/Web/API/HTMLMediaElement/readyState
        const callbackBlobWasDeleted = async (e, _j) => {
            console.debug(
                'Error on play(), perhaps the file was removed by browser on low system space: `',
                e,
                `audio[${_j}].src:`, audio[_j].src,
                '`; try to play from S3'
            );
            const urls = await _getPresignedUrls(hashArticle, lenChunks);
            console.debug('Received presigned urls:', urls);

            // Because of false positive https://github.com/eslint/eslint/issues/11899
            // eslint-disable-next-line require-atomic-updates
            audio[_j].src = urls[_j];

            console.debug(`Set src instead of blob - audio[${_j}].src:`, audio[_j].src);
            addEventListener('pauseOrStop', _ => {
                console.debug('Event pauseOrStop');
                _cacheChunk(urls[_j], id, _j);
            });
        };

        if (j === 0) {
            console.debug('audio[0].src before play:', audio[0].src);
            audio[0].play().then(_ => {  // start the playing chain
                console.log('Playing of the first chunk started');
                isIcoAnimating = false;
                chrome.runtime.sendMessage({
                    'toPopup': {
                        'playingStarted': true,
                        'audioCurrentFeedEntityId': audioCurrentFeedEntityId,
                        'hasNextChunk': audio[1] && audio[1].readyState === 4
                        // Short texts may consists only from one chunk
                    }
                });
                _doNotSleep();
            }).catch(e => {
                console.debug('Cannot play', audio[j].src);
                callbackBlobWasDeleted(e, j)
                    .then(_ => playFirstChunkAndAttachAudioEvents(...arguments, true));
            });
        } else {
            console.log('j:', j);
            console.log(
                'audioCurrent.dataset["index"]:', audioCurrent ? audioCurrent.dataset['index'] : ''
            );
            if (j - 1 == (audioCurrent && audioCurrent.dataset['index'])) {
                console.log('Next chunk is ready');
            }
        }

        // audio events: https://developer.mozilla.org/en/docs/Web/Guide/Events/Media_events
        audio[j].onended = _ => {
            console.log('chunk ended, i:', audioCurrent.dataset['index']);
            if (audio[j+1]) { // if has next
                console.debug('onended: next readyState:', audio[j+1].readyState,
                    'src of next before playing:', audio[j+1].src);
                if (audio[j+1].readyState === 4 || audio[j+1].src.startsWith('blob')) {
                    audio[j+1].play().catch(e => {
                        console.debug('onended play catch j:', j);
                        callbackBlobWasDeleted(e, j+1);
                        audio[j+1].oncanplay = _ => {
                            console.debug('Play from canplay event in catch');
                            audio[j+1].play();
                        };
                    });
                } else {
                    console.log('Next audio is not ready - attach event to oncanplay');
                    audio[j+1].oncanplay = _ => {
                        console.debug('Play from canplay event, j:', j+1);
                        // 'canplay': corresponds to the HAVE_ENOUGH_DATA readyState
                        // https://developer.mozilla.org/en-US/docs/Web/Guide/Events/Media_events

                        audio[j+1].play();
                    };
                }
            }
            if (j === lenChunks - 1) { // last chunk ended - silence begin
                console.debug('The last chunk was ended');
                chrome.storage.sync.get(_storageSync => {
                    // Handle switching here instead of popup because popup may not exists now.
                    if (_storageSync['isContinuousPlaying'])
                        _playNextArticle();
                    else {
                        console.log('onended stopPlaying()');
                        stopPlaying();
                    }
                });
            }
        };
    } else {  // still unavailable by the link with audio
        // 403 Forbidden because bucket is private
        console.debug('Audio still unavailable, readyState:', audio[j].readyState,
            ', networkState:', audio[j].networkState);
        // https://developer.mozilla.org/en-US/docs/Web/API/HTMLMediaElement/networkState
        // https://developer.mozilla.org/en-US/docs/Web/API/HTMLMediaElement/readyState
        if (audio[j].networkState === 3) {  // NETWORK_NO_SOURCE
            // trigger GET request
            audio[j].src = audio[j].src;  // eslint-disable-line no-self-assign
        }
        if (!j && Date.now() - gTimeStartedWaitingFirstAudio > 30000) {
            stopPlaying();
            _alertError();
            throw 'Timeout playing from feed, ' +
                'maybe authed with another account but with the same email';
        }

        if (isBlobMissing) {
            if (j === 0) {
                setTimeout(playFirstChunkAndAttachAudioEvents, 200, ...arguments);
                return;
            }
            /* Maybe was cached after install
             * or after adding to the feed and immediate playing
             * or due to the insufficient space browser deleted blob
             * (I found that in this case the record was remained in IndexedDB -
             * but this blob was unplayable).
             */
        } else {
            const callback = _ => {
                console.debug('Callback - play first chunk process again');
                setTimeout(
                    _ => {
                        const isThisChunkStillExists = !!audio[j];
                        if (isThisChunkStillExists) {
                            playFirstChunkAndAttachAudioEvents(...arguments);
                        }
                    }, j * (j < 2 ? 200 : 7000) + 10,
                    // Listen first chunks faster
                    // Without +10 is impossible to cancel all timeouts on error,
                );
            };
            if (!audio[j].src.startsWith('blob')) {
                _getAudioLinkFromCache(id, j)
                    .then(linkFromCache => {
                        console.debug('linkFromCache:', linkFromCache);
                        audio[j].src = linkFromCache;
                        // eslint-disable-next-line no-self-assign
                        console.debug(
                            'Altered audio.src from http to the blob link index:',
                            j,
                            ', new src:',
                            audio[j].src
                        );
                    })
                    .catch(e => console.debug(e))
                    .finally(callback);
            } else {
                callback();
            }
        }
    }
}

async function _playNextArticle() {
    const nextArticleID = await _getNextArticleID();
    if (nextArticleID) {
        playFromFeed(nextArticleID);
    } else {
        stopPlaying();
    }
}

async function _playPrevArticle() {
    const prevArticleID = await _getPrevArticleID();
    if (prevArticleID) {
        playFromFeed(prevArticleID);
    } else {
        stopPlaying();
    }
}

/**
 * /email/ just as example of API Gateway ability to consume nested path arguments.
 * It is mean that in API Gateway in body mapping template we can get /all/values/from/path/
 * but in such case we extract email from Cognito credentials lieu of the path args
 * because client hijacker can send any email.
 */
async function _setPlayedStatusInStorages(id, val) {
    fetch(`${stageUrl}history/email/${id}`, {  // eslint-disable-line no-undef
        'method': 'PUT',
        'headers': {
            'Authorization': (await _keepTokenFresh())['id_token'],  // eslint-disable-line no-undef
        },
        'body': String(val)
    });

    _updateIDB(id, 'isNew', val);  // eslint-disable-line no-undef
}


/** 'Next' mean older than the current.
 *
 */
function _getNextArticleID() {
    const query = audioCurrentFeedEntityId ?
        IDBKeyRange.upperBound(audioCurrentFeedEntityId, true)
        : undefined;

    return new Promise(resolve => {
        indexedDB.open('intelligent-speaker').onsuccess = event => event.target.result
            .transaction('articles')
            .objectStore('articles')
            .openKeyCursor(query, 'prev')
            .onsuccess = event => resolve(event.target.result ? event.target.result.key : null);
    });
}
function _getPrevArticleID() {
    const query = audioCurrentFeedEntityId ?
        IDBKeyRange.lowerBound(audioCurrentFeedEntityId, true)
        : undefined;

    return new Promise(resolve => {
        indexedDB.open('intelligent-speaker').onsuccess = event => event.target.result
            .transaction('articles')
            .objectStore('articles')
            .openKeyCursor(query, 'next')
            .onsuccess = event => resolve(event.target.result ? event.target.result.key : null);
    });
}


/**
 * Example of presigned url: https://intelligentspeaker.s3.amazonaws.com/
 * f4cfd4a8-0e94-4287-8c5e-1b01538dd2a1/c83626c8a374eed9615e17e958421b17/0?...args...
 * sub (uuid of user in Cognito) / hash of article / id of chank
 */
function _getMinimalUrlRepresentation(presignedUrls) {
    return {
        'hashArticle': presignedUrls[0].split('/')[4],
        'lenChunks':  presignedUrls.length
    };
}


async function _getPresignedUrls(hashArticle, voice, lenChunks, idToken) {
    console.log(
        `_getPresignedUrls(): hashArticle: ${hashArticle}, voice: ${voice}, lenChunks: ${lenChunks}`
    );

    if (this[hashArticle]) {
        return this[hashArticle];
    }

    try {
        const resp = await fetch(`${stageUrl}get-presigned-urls`, {  // eslint-disable-line no-undef
            'method': 'POST',
            'headers': {
                // eslint-disable-next-line no-undef
                'Authorization': idToken || (await _keepTokenFresh())['id_token'],
                'Content-Type': 'application/json'},
            'body': JSON.stringify({hashArticle, voice, lenChunks})
        });
        const resp_json = await resp.json();
        this[hashArticle] = resp_json;
        return resp_json;
    } catch(e) {
        _alertError();
        stopPlaying();
        throw e;
    }
}

function prevChunk() {
    const audioChunkPrevious = _getChunkPrevious();
    console.debug('prevChunk(), audioChunkPrevious:', audioChunkPrevious);
    if (!audioChunkPrevious) {
        return;
    }
    audioCurrent.pause();
    audioCurrent.currentTime = 0;    // for when this chunk will play again - start with start

    audioChunkPrevious.play();
}
function nextChunk() {
    const audioNext = _getChunkNext();
    console.debug('nextChunk(), audioNext:', audioNext);
    if (!audioNext || !audioNext.src) {
        // audioNext is missing when     tried to jump at the last chunk
        // audioNext.src is missing when tried to jump to the chunk that still on the queue
        return;
    }

    audioCurrent.pause();
    audioCurrent.oncanplay = null;
    // Looks like the next line with `currentTime = 0` fire 'canplay` of audioCurrent
    audioCurrent.currentTime = 0;  // for when this chunk will play again - start with start

    audioNext
        .play()
        /* Next chunk may be not ready from S3 - we disable nextChunk button not in realtime -
         * we use message passing between event page and popup page.
         */
        .catch(_ => setTimeout(nextChunk, 99));
}


/**
 * Content script get html or text from page, maybe using some API,
 * for example when Wikipedia.
 * @see {@link https://developer.chrome.com/extensions/tabs#method-executeScript}
 *
 * Firstly we pass args and after that inject the file -
 * this is the only way to inject script with variables.
 */
function injectScript(args) {
    // Without stringify will print [object Object]
    chrome.tabs.executeScript({'code': `args = ${JSON.stringify(args)}`}, _ => {
        if (chrome.runtime.lastError &&
            chrome.runtime.lastError.message.startsWith(
                'Cannot access contents of the page')) {
            // Looks like this problem only when opened `chrome://extensions`?
            // TODO try again?
            _getActiveTab(tabActive => {  // eslint-disable-line no-undef
                console.error(
                    '%c`Can not access contents of the page` (click to tab for fix), current tab:',
                    'font-size: large',
                    tabActive
                );
                throw 'My custom error - cannot access the content of the page';
            });
        } else {
            chrome.tabs.executeScript({'file': 'contentScript.js'});
        }
    });
}


function stopPlaying() {
    console.log('stopPlaying(): audioCurrentFeedEntityId:', audioCurrentFeedEntityId);

    chrome.runtime.sendMessage({
        'toPopup': {
            'playingFinished': true
        }
    });

    // We need to clear it after error when user offline and no audioCurrent
    audioCurrentFeedEntityId = null;
    // this is not always necessary but we save code from additional IF

    // Pause audio first - against a case when next chunk suddenly appear to play.
    if (audioCurrent) {
        /** Case: no current audio and stopPlaying() called:
         *  playing not started because of exhausted limit.
         */

        audioCurrent.pause();
        // When last chunk ended - no need to pause, but it is simpler without IF

        audioCurrent = null;
        audio = [];
    }

    isIcoAnimating = false; // For the case when stopPlaying() called in catch()

    _clearAllTimeouts();

    dispatchEvent(new Event('pauseOrStop'));
}


/**
 * Validating of `time` against
 * `Uncaught Error:
 * `Invocation of form remove(undefined) doesn't match definition
 *  remove(string or array keys, optional function callback)`
 */
function removeStubFromFeed(time) {
    if (!time) {
        return;
    }
    _deleteArticle(time);  // eslint-disable-line no-undef
}


/**
 *  Our target here - timeouts about playing next chunk.
 *  TODO but it will also stopPlaying caching.
 *
 * @see {@link https://stackoverflow.com/questions/3847121/how-can-i-disable-all-settimeout-events}
 */
function _clearAllTimeouts() {
    const highestId = setTimeout(_ => {});
    for (let i = highestId; i > 0; i--)
        clearTimeout(i);
}


/**
 * This event page is not persistent - this mean that it is not always in memory.
 * It loads from events - after a few seconds of inactivity extension will unloaded.
 * To prevent unloading when audio playing - we have this dummy function that do some action.
 * Currently it do useful thing without polluting the Network tab.
 *
 * @see {@link https://developer.chrome.com/extensions/event_pages}
 * @see {@link https://bugs.chromium.org/p/chromium/issues/detail?id=740097|
 *     opened bug that event page unloaded when audio playing}
 */
function _doNotSleep() {
    if (audioCurrent)
        setTimeout(_ => {
            chrome.runtime.sendMessage({
                'toPopup': {
                    'hasNextChunk': !!(_getChunkNext() && _getChunkNext().readyState === 4),
                    'index': audioCurrent && audioCurrent.dataset['index']
                }
            }, _ => chrome.runtime.lastError);
            /** lastError checking: for Firefox when popup is closed - against error in the console:
            /* `Error: Could not establish connection. Receiving end does not exist.`
             */
            _doNotSleep();
        }, 999);
}

function _getChunkNext() {
    return audioCurrent && audio[+audioCurrent.dataset['index'] + 1];
}
function _getChunkPrevious() {
    return audioCurrent && audio[audioCurrent.dataset['index'] - 1];
}


async function _cache(urls, id, isUpdating, debug) {
    stillCachingIds.add(id);
    let indexesForCaching = [];

    if (isUpdating) {
        indexesForCaching = await _getIndexesForCaching(id, urls.length);
    } else {

        // TODO remove this debug code
        const type = typeof urls.map;
        if (type !== 'function') {
            throw new Error(
                `typeof urls.map: ${type}; typeof urls: ${typeof urls}; debug: ${JSON.stringify(debug)}`
            );
        }

        indexesForCaching = urls.map((_, i) => i);
    }

    indexesForCaching
        .forEach(i => {
            const args = [urls[i], id, i, urls.length, urls.length - 1 === i];
            setTimeout(_cacheChunk, i*3000, ...args);
        });
}function _getIndexesForCaching(id, length) {
    const indexes = [];
    return new Promise(resolve => getFromObjectStore(id)  // eslint-disable-line no-undef
        .then(item => {
            for (let i = 0; i < length; i++) {
                if (!item['cache'] || !item['cache'][i]) {
                    indexes.push(i);
                }
            }
            resolve(indexes);
        })
    );
}
function _cacheChunk(url, id, i, lenChunks, isLastChunk) {
    console.debug(arguments.callee.name, arguments);

    /** TODO against SSD IO - replace to IndexedDB observer when will be available
     * https://bugs.chromium.org/p/chromium/issues/detail?id=609934
     * https://bugzilla.mozilla.org/show_bug.cgi?id=1059724
     */
    (function _recursion(iWasHere=0) {
        console.log('iWasHere:', iWasHere);
        getFromObjectStore(id).then(item => {  // eslint-disable-line no-undef
            if (!item) {
                console.log('Not found in IndexedDB, do not cache it.');
                return;
                // Article was deleted when still caching
                // or logout cleared storage
            }

            if (iWasHere > 40) {
                console.debug('I tried enough to cache this chunks, no more.');
                _deleteArticleLocallyThatUnavailableSoLong(id);
                return;
            }

            fetch(url)
                .then(resp => {
                    if (resp.ok)
                        return resp.blob();
                    else {
                        // 403: audio still not at S3
                        throw '';  // Move to catch()
                    }
                })
                .then(blob => {
                    // eslint-disable-next-line no-undef
                    _updateIDB(id, 'cache', blob, i)
                        .then(_ => {
                            if (_cacheChunk[id]) {
                                _cacheChunk[id]['count']++;
                            } else {
                                _cacheChunk[id] = {'count': 1};
                            }
                            chrome.runtime.sendMessage({'toPopup': {
                                'cachedChunkId': id,
                                'count': _cacheChunk[id]['count'],
                                lenChunks
                            }});
                            if (isLastChunk) {
                                stillCachingIds.delete(id);
                            }
                        });
                })
                .catch(_ => setTimeout(_recursion, 2000, ++iWasHere)); // 403 and offline
        });
    })();
}
function _deleteArticleLocallyThatUnavailableSoLong(id) {
    const key = 'howManyTimesWasNotAvailableToFetch_' + id;
    const countBeforeIncrement = +localStorage.getItem(key);

    if (countBeforeIncrement > 9) {
        console.debug('Looks like audio chunks was not synthesized, remove this article locally');
        _deleteArticle(id);  // eslint-disable-line no-undef
    }

    localStorage.setItem(
        key,
        countBeforeIncrement + 1);
}

function _getAudioLinkFromCache(id, i) {
    console.log(arguments.callee.name, arguments);
    return new Promise((resolve, reject) => {
        getFromObjectStore(id).then(item => {  // eslint-disable-line no-undef
            if (item && item['cache'] && item['cache'][i]) {
                resolve(URL.createObjectURL(item['cache'][i]));
            } else {
                reject();
            }
        });
    });
}

chrome.commands.onCommand.addListener(command => {
    const mapping = {
        addToFeedStarter,
        'listenToggle': _ => {
            if (audioCurrent) {
                if (audioCurrent.paused) {
                    audioCurrent.play();
                } else {
                    audioCurrent.pause();
                }
            } else {
                _playNextArticle();
            }
        },
        'nextArticle': _ => {
            if (audioCurrent) {
                audioCurrent.pause();
                audio = [];
            }
            _playNextArticle();
        },
        nextChunk,
        'prevArticle': _ => {
            if (audioCurrent) {
                audioCurrent.pause();
                audio = [];
            }
            _playPrevArticle();
        },
        prevChunk,
        speedIncrease,
        speedDecrease
    };
    mapping[command]();
});

const playbackRates = [0.8, 1, 1.5, 1.8, 2];

/**
 * speedIncrease function name but not playbackRateIncrease -
 * for ordering by name on chrome://extensions/shortcuts
 */
function speedIncrease() {
    chrome.storage.sync.get(resp => {
        if (resp['playbackRate'] === '2') {
            return;
        }
        const i = playbackRates.indexOf(+resp['playbackRate']) + 1;
        const playbackRate = playbackRates[i];
        chrome.storage.sync.set({
            playbackRate
        });
        _setPlaybackRateToCurrentAudio(playbackRate);
    });
}
function speedDecrease() {
    chrome.storage.sync.get(resp => {
        if (resp['playbackRate'] === '0.8') {
            return;
        }
        const i = playbackRates.indexOf(+resp['playbackRate']) - 1;
        const playbackRate = playbackRates[i];
        chrome.storage.sync.set({
            playbackRate
        });
        _setPlaybackRateToCurrentAudio(playbackRate);
    });
}
function _setPlaybackRateToCurrentAudio(val) {
    if (audioCurrent)
        audioCurrent.playbackRate = val;

    audio.forEach(a => {
        /** Alter two attributes - because defaultPlaybackRate applied to ended and not started
         *  while playbackRate applied to switched from tracks -
         *  on scrolling through audio using prev/next buttons.
         */
        a.playbackRate = a.defaultPlaybackRate = val;
    });
}
