cat ../../extension/popup.html | while read line; do

    if [[ $line =~ data-lang=\'(.*)\' ]]; then
        lang="${BASH_REMATCH[1]}"
    fi

    if [[ $line =~ data-voice=\'([a-zA-Z]*)\'.data-preview ]]; then
        voice=${BASH_REMATCH[1]}
        translated=$(curl -s -X POST -H "Content-Type: application/json" \
        -H "Authorization: Bearer "$(gcloud auth application-default print-access-token) \
        --data "{
          'q': 'Good day, my name is $voice, I will be glad to read texts for you',
          'target': '$lang',
          'format': 'text'
          }" "https://translation.googleapis.com/language/translate/v2" | jq '.data.translations[0].translatedText')

        echo 'voice: '$voice
        echo 'translated: '$translated
        perl -pi -e  "s/$voice' data-preview=".*"\>/$voice' data-preview=$translated\>/g" ../../extension/popup.html
    fi

done
